unit Codec;


interface

uses
  Winapi.Windows,
  Winapi.Messages,
  System.SysUtils;


type TCodec = class

const G711U_TEXT = 'G711u-Law';
const G711A_TEXT = 'G711a-Law';
const ILBC_TEXT = 'iLBC';
const G610_TEXT = 'GSM6.10';
const G729_TEXT = 'G729';

const VAX_CODEC_GSM610 = 0;
const VAX_CODEC_ILBC = 1;
const VAX_CODEC_G711A = 2;
const VAX_CODEC_G711U = 3;
const VAX_CODEC_G729 = 4;

const TOTAL_SIZE_CODEC = 5;

public

function GetCodecNo(sCodecName : string) : string ;
function GetCodecName(sCodecNo : string) : string ;

end;


implementation

function TCodec.GetCodecNo(sCodecName : string) : string ;

var
arrCodecList : Array[0..4] of string;
nIndex : Integer;

begin

    arrCodecList[0] := G610_TEXT;
    arrCodecList[1] := ILBC_TEXT;
    arrCodecList[2] := G711A_TEXT;
    arrCodecList[3] := G711U_TEXT;
    arrCodecList[4] := G729_TEXT;

    for nIndex := 0 to TOTAL_SIZE_CODEC - 1 do
    begin
        if(sCodecName <> arrCodecList[nIndex]) then
            continue;

        Result := IntToStr(nIndex);
        exit;
    end;

end;

function TCodec.GetCodecName(sCodecNo : string) : string ;

var
nCodecNo : Integer;


begin

nCodecNo := StrToInt(sCodecNo);

case nCodecNo Of

    VAX_CODEC_G711U:
        Result := G711U_TEXT;

    VAX_CODEC_G711A:
        Result := G711A_TEXT;

    VAX_CODEC_ILBC:
        Result := ILBC_TEXT;

    VAX_CODEC_GSM610:
        Result := G610_TEXT;

    VAX_CODEC_G729:
        Result := G729_TEXT;
end;

end;

end.
