#pragma once

class CQueueAgentList;

class CQueueDetails
{

public:

	CQueueDetails();
	~CQueueDetails();


private:

	CQueueAgentList* m_pQueueAgentList;

public:

	CString m_sQueueName;

	CString m_sQueueMusicFile;
	CString m_sQueueDialToneFile;

	int m_nQueueMusicId;
	int m_nQueueDialToneId;
	
	int m_nProcessMode;
	int m_nProcessType;

public:

	BOOL AddQueueAgent(LPCTSTR sAgentName);
	BOOL IsAgentExist(LPCTSTR sAgentName);

	BOOL GetQueueAgentList(CStringList& sListAgentName);

	void RemoveQueueAgent(LPCTSTR sAgentName);
	
	CString GetQueueAgentAt(int nIndex);
	int GetQueueAgentCount();

};

////////////////////////////////////////////////

typedef CMap<CString, LPCTSTR, CQueueDetails*, CQueueDetails*> CQueueDetailsList;

class CQueueList
{

public:

	CQueueList(void);
	~CQueueList(void);

private:

	CQueueDetailsList m_objQueueDetailsList;

public:

	BOOL AddQueue(LPCTSTR sQueueName, LPCTSTR sQueueMusic, int nQueueMusicId, LPCTSTR sQueueDialToneFile, int nQueueDialToneId);
	void RemoveQueue(LPCTSTR sQueueName);

	BOOL AddQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName);
	void RemoveQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName);
	
	void SetQueueProcessMode(LPCTSTR sQueueName, int nProcessMode, int nProcessType);
	BOOL GetQueueDetails(LPCTSTR sQueueName, int& nProcessMode, int& nProcessType, CStringList& sListQueueAgent, CString& sQueueMusicFile, CString& sQueueDialToneFile);

	BOOL IsAgentExisted(LPCTSTR sQueueName, LPCTSTR sAgentName);

	BOOL GetQueueNameList(CStringList& sListQueueName);
	CString GetQueueAgentAt(LPCTSTR sQueueName, int nIndex);

	int GetQueueAgentCount(LPCTSTR sQueueName);
	
	int GetQueueMusicId(LPCTSTR sQueueName);
	int GetQueueDialToneId(LPCTSTR sQueueName);

	void DeleteQueueAll();
};



