#include "stdafx.h"
#include "VaxServerSIP.h"
#include "StoreRegistry.h"
#include "StoreCOMM.h"
#include "StoreUser.h"
#include "StoreLine.h"
#include "StoreDirectProxy.h"
#include "StoreRoom.h"
#include "StoreRingGroup.h"
#include "StoreQueue.h"
#include "StoreCallPickUp.h"
#include "VaxSettingDefault.h"


CVaxSettingDefault::CVaxSettingDefault(CVaxServerSIP* pServerSIP)
{
	m_pServerSIP = pServerSIP;
}

CVaxSettingDefault::~CVaxSettingDefault(void)
{
}

BOOL CVaxSettingDefault::LoadUserDefault()
{
	CStoreUser objStoreUser;

	if(objStoreUser.IsDataStored())
		return FALSE;
	
	for(int nCount = 4040; nCount < 4050; nCount++)
	{
		CString sLogin;
		sLogin.Format("%d", nCount);

		m_pServerSIP->AddUser(sLogin, sLogin, "32014", FALSE, "", "", -1, "", TRUE);
	}

	return TRUE;
}

BOOL CVaxSettingDefault::LoadQueueDefault()
{
	CStoreQueue objStoreQueue;

	if(objStoreQueue.IsDataStored())
		return FALSE;
	
	m_pServerSIP->AddQueue("Queue-Support", "..\\WaveFiles\\Queue.wav", "..\\WaveFiles\\DialTone.wav");
	m_pServerSIP->AddQueueAgent("Queue-Support", "4040");
	m_pServerSIP->AddQueueAgent("Queue-Support", "4041");
	m_pServerSIP->AddQueueAgent("Queue-Support", "4045");
	m_pServerSIP->SetQueueProcessMode("Queue-Support", VAX_QUEUE_ALGO_ROUND_ROBIN, VAX_QUEUE_MODE_FREE);

	m_pServerSIP->AddQueue("Queue-Technical", "..\\WaveFiles\\Queue.wav", "..\\WaveFiles\\DialTone.wav");
	m_pServerSIP->AddQueueAgent("Queue-Technical", "4040");
	m_pServerSIP->AddQueueAgent("Queue-Technical", "4041");
	m_pServerSIP->AddQueueAgent("Queue-Technical", "4042");
	m_pServerSIP->SetQueueProcessMode("Queue-Technical", VAX_RING_GROUP_ALGO_LEAST_ANSWERED, VAX_QUEUE_MODE_FREE);

	return TRUE;
}

BOOL CVaxSettingDefault::LoadRingGroupDefault()
{
	CStoreRingGroup objStoreRingGroup;

	if(objStoreRingGroup.IsDataStored())
		return FALSE;
	
	m_pServerSIP->AddRingGroup("RingGroup-Team");
	m_pServerSIP->AddRingGroupAgent("RingGroup-Team", "4040");
	m_pServerSIP->AddRingGroupAgent("RingGroup-Team", "4041");
	m_pServerSIP->AddRingGroupAgent("RingGroup-Team", "4042");
	m_pServerSIP->SetRingGroupProcessMode("RingGroup-Team", VAX_RING_GROUP_ALGO_RING_ALL, VAX_RING_GROUP_MODE_FREE);

	m_pServerSIP->AddRingGroup("RingGroup-Design");
	m_pServerSIP->AddRingGroupAgent("RingGroup-Design", "4040");
	m_pServerSIP->AddRingGroupAgent("RingGroup-Design", "4041");
	m_pServerSIP->AddRingGroupAgent("RingGroup-Design", "4042");
	m_pServerSIP->SetRingGroupProcessMode("RingGroup-Design", VAX_RING_GROUP_ALGO_HUNT_RANDOM, VAX_RING_GROUP_MODE_FREE);

	return TRUE;
}

BOOL CVaxSettingDefault::LoadCallPickUpGroupDefault()
{
    CStoreCallPickUp objStorePickUpGroup;

	if(objStorePickUpGroup.IsDataStored())
		return FALSE;
	
	m_pServerSIP->AddCallPickUpGroup("PickupGroup-Accounts");

	m_pServerSIP->AddCallPickUpGroupMember("PickupGroup-Accounts", "4040");
	m_pServerSIP->AddCallPickUpGroupMember("PickupGroup-Accounts", "4041");
	m_pServerSIP->AddCallPickUpGroupMember("PickupGroup-Accounts", "4042");
	m_pServerSIP->AddCallPickUpGroupMember("PickupGroup-Accounts", "4043");
	m_pServerSIP->AddCallPickUpGroupMember("PickupGroup-Accounts", "4044");
	m_pServerSIP->AddCallPickUpGroupMember("PickupGroup-Accounts", "4045");

	return TRUE;
}

BOOL CVaxSettingDefault::LoadLineDefault()
{
	CStoreLine objStoreLine;

	if(objStoreLine.IsDataStored())
		return FALSE;
	
	m_pServerSIP->AddLine("Line", "9090", "9090", "9090", "9090", "192.168.0.119", "192.168.0.119", "01234", false, -1, "", false, "", "", "Queue-Support");
	return TRUE;
}

BOOL CVaxSettingDefault::LoadRoomDefault()
{
	CStoreRoom objStoreRoom;

	if(objStoreRoom.IsDataStored())
		return FALSE;
	
	m_pServerSIP->AddRoom("Room-TechTalk", "8888");
	return TRUE;
}