﻿Public Class cStoreUser
    Inherits cStoreRegistry

    Private Const USER_ROOT_PATH = "Users\"

    Public Sub New()

    End Sub

    '////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////

    Public Function AddUser(ByVal sUserName As String, ByVal sPassword As String, ByVal sCodecList As String, ByVal bBlocked As Boolean) As Boolean

        If (sUserName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = USER_ROOT_PATH + sUserName

        MyBase.SetTEXT(sPath, "UserName", sUserName)
        MyBase.SetTEXT(sPath, "Password", sPassword)
        MyBase.SetTEXT(sPath, "CodecList", sCodecList)

        MyBase.SetBOOL(sPath, "Blocked", bBlocked)

        Return True

    End Function

    Public Sub RemoveUser(ByVal sUserName As String)

        If (sUserName.Length = 0) Then
            Return
        End If

        Dim sPath As String = USER_ROOT_PATH + sUserName
        MyBase.DeleteSubKey(sPath)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Public Function GetUser(ByVal sUserName As String, ByRef sPassword As String, ByRef sCodecList As String, ByRef bBlocked As Boolean) As Boolean

        If (sUserName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = USER_ROOT_PATH + sUserName

        MyBase.GetTEXT(sPath, "Password", sPassword)
        MyBase.GetTEXT(sPath, "CodecList", sCodecList)

        MyBase.GetBOOL(sPath, "Blocked", bBlocked)

        Return True

    End Function

    Public Function GetUserNameAll(ByRef objLoginList As List(Of String)) As Boolean

        objLoginList.Clear()

        Dim sPath As String = USER_ROOT_PATH
        Return MyBase.EnumSubKeys(sPath, objLoginList)

    End Function

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Public Function AddUserRoute(ByVal sUserName As String, ByVal sUserPrefix As String, ByVal sDialPrefix As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String) As Boolean

        If (sUserName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = USER_ROOT_PATH + sUserName

        MyBase.SetTEXT(sPath, "UserPrefix", sUserPrefix)
        MyBase.SetTEXT(sPath, "DialPrefix", sDialPrefix)

        MyBase.SetTEXT(sPath, "ToPeerName", sToPeerName)
        MyBase.SetINT(sPath, "ToPeerType", nToPeerType)

        Return True

    End Function

    Public Function GetUserRoute(ByVal sUserName As String, ByRef sUserPrefix As String, ByRef sDialPrefix As String, ByRef nToPeerType As Integer, ByRef sToPeerName As String) As Boolean

        If (sUserName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = USER_ROOT_PATH + sUserName

        MyBase.GetTEXT(sPath, "UserPrefix", sUserPrefix)
        MyBase.GetTEXT(sPath, "DialPrefix", sDialPrefix)

        MyBase.GetTEXT(sPath, "ToPeerName", sToPeerName)
        MyBase.GetINT(sPath, "ToPeerType", nToPeerType)

        Return True

    End Function

    Public Function RemoveUserRoute(ByVal sUserName As String) As Boolean

        If (sUserName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = USER_ROOT_PATH + sUserName

        MyBase.DeleteValue(sPath, "UserPrefix")
        MyBase.DeleteValue(sPath, "DialPrefix")

        MyBase.DeleteValue(sPath, "ToPeerName")
        MyBase.DeleteValue(sPath, "ToPeerType")

        Return True

    End Function

    Public Function IsDataStored() As Boolean

        Return MyBase.IsKeyExist(USER_ROOT_PATH)

    End Function

End Class
